Форум программистов, компьютерный форум CyberForum.ru
Наши страницы

С++ для начинающих

Войти
Регистрация
Восстановить пароль
 
yoghurt92
374 / 345 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
#1

try-catch - C++

24.01.2013, 14:34. Просмотров 500. Ответов 4
Метки нет (Все метки)

Доброго времени суток, начал изучать исключения, и вот есть такой код:

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    else if(num2 == 0)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
А потом захотел сделать несколько блоков catch чтобы посмотреть как это все работает, но получил сам ошибку...

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
// new.cpp : Defines the entry point for the console application.
//
 
#include "stdafx.h"
#include <iostream>
#include <locale.h>
using namespace std;
 
/*определения класса DivideByZeroErrorиспользуемого при 
обработке исключения, генерируемого делением на нуль*/
class DivideByZeroError
{
    public:
        DivideByZeroError():message(L"Деление на нуль!") {}
        DivideByZeroError(int _num):message(L"Деление на нуль!"), num(_num) {}
        void printMessage() const {wcout << message; }
 
    private:
        const wchar_t *message;
        int num;
};
 
/*описание функции quotient, которая используется чтобы показать
генерацию исключения при ошибке деления на нуль*/
float quotient(int num1, int num2)
{
    if(num2 == 0)
        throw DivideByZeroError(num2);
    else if(num2 == 1)
        throw DivideByZeroError();
 
    return (float) num1 / num2;
}
 
int _tmain(int argc, _TCHAR* argv[])
{
    wcout.imbue(locale(".866"));
    wcout << L"Введите два целых числа для расчета их частного: ";
 
 
    int number1, number2;
    cin >> number1 >> number2;
 
    try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
 
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    catch(DivideByZeroError error1(number2)) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error1.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
 
    return 0;       //нормальное завершение
}
и вот что вылезло...

C++
1
2
 error C2061: syntax error : identifier 'number2'
 error C2228: left of '.printMessage' must have class/struct/union
Заранее благодарю за помощь!
0
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
24.01.2013, 14:34
Здравствуйте! Я подобрал для вас темы с ответами на вопрос try-catch (C++):

Try catch - C++
try { throw pDoc-&gt;C; } catch (City) { return; } есть динамический City* C, ему присвается значение другого такого...

Try и catch - C++
Пытался сделать простую структуру,чтобы в блоке try задавалось значение переменной x, и если это значение равно,например, 5,то блок catch...

try-catch - C++
Какой тип проекта создавать в Visual Studio чтобы можно было сделать обработку исключений с try-catch? Или что сделать в Code Blocks с той...

try catch - C++
Здравствуйте. В c++ новичёк, с try catch никогда толком не работал, а тут пришлось. Нужно сделать защиту от ввода всего кроме цифр. вот...

try-catch - C++
Читаю книгу Страуструпа. Он пишет (стр 232), что можно не передавать обработчику исключений какое либо значение. #include...

Try-catch - C++
Добрый вечер, #include &lt;iostream&gt; using namespace std; void F1(int); void F2(int, int); void F3(int, int, int);

Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
Toshkarik
1141 / 858 / 51
Регистрация: 03.08.2011
Сообщений: 2,384
Завершенные тесты: 1
24.01.2013, 14:51 #2
Цитата Сообщение от yoghurt92 Посмотреть сообщение
catch(DivideByZeroError error1(number2))
Вы где такое вообще вычитали? Это не верный синтаксис.

Добавлено через 5 минут
Вы видать не понимаете принцип работы исключений. В блоках catch "ловятся" объекты классов исключений. По аналогии можно привести функцию, которая принимает в качестве параметра некий объект, catch блок, точно так же, принимает объект исключения. Причем лучше его принимать по ссылке.
C++
1
catch(DivideByZeroError &error)
0
yoghurt92
374 / 345 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
24.01.2013, 14:55  [ТС] #3
Toshkarik, спасибо, так а как тогда должен выглядеть следующий блок catch?
0
Toshkarik
1141 / 858 / 51
Регистрация: 03.08.2011
Сообщений: 2,384
Завершенные тесты: 1
24.01.2013, 15:04 #4
yoghurt92, блоки catch нужны для каждого типа исключения, которое нужно поймать. Функция ведь не обязательно выбрасывает одно исключение.
Например, создадим новый класс исключения:

C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
class OutOfRange {
 public:
   OutOfRange( std::wstring &str = L"Out of range" )
      : error( str )
   {
      
   }
 
   const std::wstring &getMessage() const {
      return error;
   }
 
 private:
   std::wstring error;
};
И добавим его в функцию для ограничения диапазона чисел:

C++
1
2
3
4
5
6
7
8
9
10
float quotient( int num1, int num2 )
{
    if ( num2 == 0 )
        throw DivideByZeroError();
 
    if ( num1 > 1000 || num2 > 2000 )
        throw OutOfRange();
 
    return (float) num1 / num2;
}
Тогда уже можно добавить второй catch блок:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
try{//включает код, который может сгенерировать исключение
        float result = quotient(number1, number2);
 
        wcout << L"Частное равно: " << result << "\n";
    }
    catch(DivideByZeroError error) {//обработчик ошибки
        wcout << L"ОШИБКА!";
        error.printMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
    catch(OutOfRange &error) {//обработчик ошибки
        wcout << L"ОШИБКА!: " << error1.getMessage();
        cout << "\n";
 
        return 1;           //завершение при ошибке
    }
В классе DivideByZero переменная num лишняя.
1
yoghurt92
374 / 345 / 22
Регистрация: 17.05.2012
Сообщений: 1,049
24.01.2013, 15:08  [ТС] #5
Toshkarik, спасибо, разобрался)
0
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
24.01.2013, 15:08
Привет! Вот еще темы с ответами:

TRY/CATCH - C++
Здравствуйте! У меня есть: MASS; для простоты пояснения, x=rand();y=rand(),znacheniye=rand(); Как игнорировать ошибки...

try . catch - C++
можно ли провести данную операцию для функции erase у вектора??? пытался, что-то не получилось: #include &lt;vector&gt; #include &lt;algorithm&gt; ...

Блок try-catch - C++
В некоторых программах он хорошо работает и в блоке catch выводит то что написал, а в некоторых среда VS говорит &quot;Необработанное исключение...

Снова try catch - C++
Доброе утро всем!:) Недавно спрашивала как работать с блоками try ... catch. В общем, прозрение так и не пришло, но доделать код хочется....


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
Yandex
Объявления
24.01.2013, 15:08
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2017, vBulletin Solutions, Inc.
Рейтинг@Mail.ru